<template>
  <div class="fit row q-pt-sm justify-between items-start content-start">
    <svg class="col-8  border text-center bg-white" id="myDiv" ref="myDiv" style="height: 85vh">
    </svg>
    <div class="col-4 text-center q-pl-sm q-pb-xs">
      <Card
        :images="variableconimagen"
        :node="nodeData"
        v-if="validator"
      />
      <Symbology
        class="bg-white border"
        :class="{ 'q-mt-sm': validator === true }"
      />
    </div>
  </div>
</template>

<script>
import Viva from 'vivagraphjs'
import $ from 'jquery'
// import graphJSON from 'src/example.json'
import { sortByID, sortByDepth, findDepthOnLinks, transform } from 'src/functions.js'
import { colorRange, computeForcedLayout } from 'src/render.js'
import Card from 'components/Card.vue'
import Symbology from 'components/Symbology.vue'
import axios from 'axios'
// import svgPanZoom from 'svg-pan-zoom'

const nodeSize = 80
const HIGHLIGHT_TEXT_FONT_WEIGHT = 'bold'
const HIGHLIGHT_TEXT_FONT_SIZE = '24'
const HIGHLIGHT_TEXT_COLOR = 'black'
const NORMAL_TEXT_FONT_WEIGHT = ''
const NORMAL_TEXT_FONT_SIZE = '14'
const NORMAL_TEXT_COLOR = 'gray'

export default {
  name: 'Graph',
  components: { Card, Symbology },
  props: {
    id: {
      type: String,
      required: true
    },
    nodes: {
      type: String,
      required: true
    }
  },
  data () {
    return {
      nodeData: {},
      validator: false,
      zoom: 8,
      graph1: [],
      variableconimagen: '',
      covid: ''
    }
  },
  beforeMount () {
    this.$q.loading.show({
      message: '<h6>Analizando</h6>',
      backgroundColor: 'primary',
      spinnerColor: 'secondary'
    })

    axios.get('http://146.83.95.14:8081/api/backend/get-graph/' + this.id + '/' + this.nodes + '/')
      .then((res) => {
        this.calculateGraph(res.data.graph)
      })
      .catch((err) => {
        console.log(err)
      })
      .finally(() => {
        this.$q.loading.hide()
      })
  },
  methods: {
    calculateGraph (arrayGraph) {
      console.log('terminé la lesera estoy en función calculateGraph()', arrayGraph)

      // PREPARACIÓN DE DATOS PREVIOS AL RENDER, PROVISTO POR BACKEND
      const nodesT = arrayGraph
      console.log('Nodos en json', nodesT)

      const nodesByID = sortByID(nodesT)
      console.log('Nodos ordenados por ID', nodesByID)

      let nodes = sortByDepth(nodesByID)
      console.log('Nodos ordenados por depth', nodes)

      const newOrder = []
      const isAdded = Array(nodes.length).fill(false)

      nodes.forEach((node) => {
        if (!isAdded[node.id]) {
          isAdded[node.id] = true
          newOrder.push(node)
          if (node.links !== []) findDepthOnLinks(nodesByID, newOrder, isAdded, node.links)
        }
      })
      console.log('newOrder', newOrder)
      nodes = newOrder

      // Nodos con covid
      const nodesCovid = []
      nodes.forEach(function (node) {
        if (node.metadata.covid === true) {
          nodesCovid.push(node.id)
        }
      })
      console.log(nodesCovid)

      // -- FIN DE LA PREPARACIÓN --

      // VIVAGRAPH
      const pinnedNodeID = '0'
      const sizeMin = 2 * nodeSize * 2
      const sizeMax = 800
      const min = 1
      const max = 100

      // Creación del grafo
      const graph = Viva.Graph.graph()

      // Agregar nodos
      nodes.map((item, i) => {
        return graph.addNode(item.id, item)
      })

      // Agregar links
      nodes.map((item, rot) => {
        return item.links.map((link, rot2) => {
          const color = colorRange(transform(link.m, min, max, 0, 100))
          graph.addLink(item.id, link.id, {
            linkLength: transform(link.m, min, max, sizeMin, sizeMax),
            fromId: item.id,
            toId: link.id,
            id: item.id + '_' + link.id,
            m: link.m,
            rotation: transform(rot + rot2 + 2, 2, nodes.length, 15, 180),
            color: color
          })
          return graph
        })
      })

      const DirectLayout = computeForcedLayout(pinnedNodeID, graph, nodes)

      // Set svg properties
      const graphics = Viva.Graph.View.svgGraphics()
      const width = $(window).width()
      const height = $(window).height()

      graphics.getSvgRoot()
        .attr('width', width * 0.666667).attr('height', height * 0.85)

      // METHOD HIGHLIGHT NODE
      function highlightRelatedNodes (nodeId, isOn) {
        graph.forEachLinkedNode(nodeId, function (node, link) {
          const linkUI = graphics.getLinkUI(link.id)
          if (linkUI) {
            highlightLink(linkUI, isOn)
          }
        })
      }

      // METHOD HIGHLIGHT LINK
      function highlightLink (linkUI, isOn) {
        const id = '#' + linkUI.attr('labelId')
        const label = $(id)
        if (label) {
          if (isOn) {
            linkUI.attr('stroke-width', 5)
            label.css('font-weight', HIGHLIGHT_TEXT_FONT_WEIGHT)
            label.css('font-size', HIGHLIGHT_TEXT_FONT_SIZE)
            label.css('color', HIGHLIGHT_TEXT_COLOR)
          } else {
            linkUI.attr('stroke-width', 2)
            label.css('font-weight', NORMAL_TEXT_FONT_WEIGHT)
            label.css('font-size', NORMAL_TEXT_FONT_SIZE)
            label.css('color', NORMAL_TEXT_COLOR)
          }
        }
      }

      // NODE IMAGE SETTINGS
      graphics.node(node => {
        const img = 'http://146.83.95.14:8081/static/' + node.data.url_image + '.jpeg'
        const ui = Viva.Graph.svg('image')
          .attr('width', nodeSize)
          .attr('height', nodeSize)
          .attr('id', node.id)
          .attr('filename', img)
          .link(img)
        // Set outline for pinned node
        if (node.id === pinnedNodeID) ui.attr('style', 'filter: drop-shadow(5px 5px 30px gold)')
        if (node.data.metadata.covid === true) ui.attr('style', 'filter: drop-shadow(5px 5px 30px red)')

        // On node click
        $(ui).click(() => {
          graph.forEachNode(n => {
            if (n.id === pinnedNodeID) {
              graphics.getNodeUI(n.id).attr('style', 'filter: drop-shadow(5px 5px 30px gold)')
            } else graphics.getNodeUI(n.id).attr('style', 'filter: none')
          })
          nodesCovid.forEach(id => graphics.getNodeUI(id).attr('style', 'filter: drop-shadow(1px 1px 20px red)'))

          if (node.data.id !== '0') {
            graphics.getNodeUI(node.id).attr('style', 'filter: drop-shadow(1px 1px 20px blue)')
          }

          console.log(node.data)

          if (node.data.id !== '0') {
            axios.get('http://146.83.95.14:8081/api/backend/get-metadata/' + node.data.instance_uid + '/')
              .then((res) => {
                console.log(res)
                this.validator = true
                this.nodeData = res.data.metadata
                this.variableconimagen = node.data.url_image
              })
              .catch((err) => {
                console.log(err)
              })
          }
          // alert(`clicked: ${JSON.stringify(node.data)}`)
        })
        $(ui).hover(() => {
          highlightRelatedNodes(node.id, true)
        }, function () { // mouse out
          highlightRelatedNodes(node.id, false)
        })
        return ui
      })

      // Adjust image position to node position
      graphics.placeNode(function (nodeUI, pos) {
        return nodeUI.attr('x', pos.x - nodeSize / 2).attr('y', pos.y - nodeSize / 2)
      })

      // LINK SETTINGS
      graphics.link(function (link) {
        const path = Viva.Graph.svg('path')
          .attr('stroke-width', 2)
          .attr('id', link.data.id)
          .attr('show', 'false')
          .attr('stroke', link.data.color)
          .attr('rotation', link.data.rotation)
          .attr('data', link.data.m)
        $(path).hover(() => {
          highlightLink(path, true)
        }, () => {
          highlightLink(path, false)
        })
        return path
      }).placeLink(function (linkUI, fromPos, toPos) {
        const data = 'M' + fromPos.x + ',' + fromPos.y + 'L' + toPos.x + ',' + toPos.y
        linkUI.attr('d', data)
        linkUI.attr('labelId', 'label_' + linkUI.attr('id'))
      })

      // RENDER THE GRAPH
      const renderer = Viva.Graph.View.renderer(graph, {
        container: this.$refs.myDiv,
        layout: DirectLayout,
        graphics: graphics,
        interactive: 'scroll drag'
      })

      renderer.run()
      renderer.reset()
    }
  } /*,
  mounted () {
    // PREPARACIÓN DE DATOS PREVIOS AL RENDER, PROVISTO POR BACKEND
    console.log('imprimiendo props desde componente', this.id, this.nodes, this.graph1)
    const nodesT = graphJSON
    console.log('Nodos en json', nodesT)

    const nodesByID = sortByID(nodesT)
    console.log('Nodos ordenados por ID', nodesByID)

    let nodes = sortByDepth(nodesByID)
    console.log('Nodos ordenados por depth', nodes)

    const newOrder = []
    const isAdded = Array(nodes.length).fill(false)

    nodes.forEach((node) => {
      if (!isAdded[node.id]) {
        isAdded[node.id] = true
        newOrder.push(node)
        if (node.links !== []) findDepthOnLinks(nodesByID, newOrder, isAdded, node.links)
      }
    })
    console.log('newOrder', newOrder)
    nodes = newOrder

    // -- FIN DE LA PREPARACIÓN --

    // VIVAGRAPH

    const pinnedNodeID = '0'
    const sizeMin = 2 * nodeSize * 2
    const sizeMax = 800
    const min = 1
    const max = 100

    // Creación del grafo
    const graph = Viva.Graph.graph()

    // Agregar nodos
    nodes.map((item, i) => {
      return graph.addNode(item.id, item)
    })

    // Agregar links
    nodes.map((item, rot) => {
      return item.links.map((link, rot2) => {
        const color = colorRange(transform(link.m, min, max, 0, 100))
        graph.addLink(item.id, link.id, {
          linkLength: transform(link.m, min, max, sizeMin, sizeMax),
          fromId: item.id,
          toId: link.id,
          id: item.id + '_' + link.id,
          m: link.m,
          rotation: transform(rot + rot2 + 2, 2, nodes.length, 15, 180),
          color: color
        })
        return graph
      })
    })
    const DirectLayout = computeForcedLayout(pinnedNodeID, graph, nodes)

    // Set svg properties
    // const width = window.innerWidth
    // const height = window.innerHeight

    const graphics = Viva.Graph.View.svgGraphics()
    const width = $(window).width()
    const height = $(window).height()

    graphics.getSvgRoot()
      .attr('width', width).attr('height', height * 0.85)

    // METHOD HIGHLIGHT NODE
    function highlightRelatedNodes (nodeId, isOn) {
      graph.forEachLinkedNode(nodeId, function (node, link) {
        const linkUI = graphics.getLinkUI(link.id)
        if (linkUI) {
          highlightLink(linkUI, isOn)
        }
      })
    }
    // METHOD HIGHLIGHT LINK
    function highlightLink (linkUI, isOn) {
      const id = '#' + linkUI.attr('labelId')
      const label = $(id)
      if (label) {
        if (isOn) {
          linkUI.attr('stroke-width', 5)
          label.css('font-weight', HIGHLIGHT_TEXT_FONT_WEIGHT)
          label.css('font-size', HIGHLIGHT_TEXT_FONT_SIZE)
          label.css('color', HIGHLIGHT_TEXT_COLOR)
        } else {
          linkUI.attr('stroke-width', 2)
          label.css('font-weight', NORMAL_TEXT_FONT_WEIGHT)
          label.css('font-size', NORMAL_TEXT_FONT_SIZE)
          label.css('color', NORMAL_TEXT_COLOR)
        }
      }
    }

    // NODE IMAGE SETTINGS
    graphics.node(node => {
      const ui = Viva.Graph.svg('image')
        .attr('width', nodeSize)
        .attr('height', nodeSize)
        .attr('id', node.id)
        .attr('filename', node.data.image)
        .link(node.data.image)
      // Set outline for pinned node
      if (node.id === pinnedNodeID) ui.attr('style', 'filter: drop-shadow(5px 5px 30px gold)')
      if (node.id === '3' || node.id === '4') ui.attr('style', 'filter: drop-shadow(5px 5px 30px red)')

      // On node click
      $(ui).click(() => {
        graph.forEachNode(n => {
          if (n.id === pinnedNodeID) {
            graphics.getNodeUI(n.id).attr('style', 'filter: drop-shadow(5px 5px 30px gold)')
          } else graphics.getNodeUI(n.id).attr('style', 'filter: none')
        })
        for (let i = 3; i <= 4; i++) {
          graphics.getNodeUI(i).attr('style', 'filter: drop-shadow(1px 1px 20px red)')
        }
        graphics.getNodeUI(node.id).attr('style', 'filter: drop-shadow(1px 1px 20px blue)')
        console.log(node.data)
        this.nodeData = node.data
        this.validator = true
        // alert(`clicked: ${JSON.stringify(node.data)}`)
      })
      $(ui).hover(() => {
        highlightRelatedNodes(node.id, true)
      }, function () { // mouse out
        highlightRelatedNodes(node.id, false)
      })
      return ui
    })

    // Adjust image position to node position
    graphics.placeNode(function (nodeUI, pos) {
      return nodeUI.attr('x', pos.x - nodeSize / 2).attr('y', pos.y - nodeSize / 2)
    })

    // LINK SETTINGS
    graphics.link(function (link) {
      const path = Viva.Graph.svg('path')
        .attr('stroke-width', 2)
        .attr('id', link.data.id)
        .attr('show', 'false')
        .attr('stroke', link.data.color)
        .attr('rotation', link.data.rotation)
        .attr('data', link.data.m)
      $(path).hover(() => {
        highlightLink(path, true)
      }, () => {
        highlightLink(path, false)
      })
      return path
    }).placeLink(function (linkUI, fromPos, toPos) {
      const data = 'M' + fromPos.x + ',' + fromPos.y + 'L' + toPos.x + ',' + toPos.y
      linkUI.attr('d', data)
      linkUI.attr('labelId', 'label_' + linkUI.attr('id'))
    })

    // RENDER THE GRAPH
    const renderer = Viva.Graph.View.renderer(graph, {
      container: this.$refs.myDiv,
      layout: DirectLayout,
      graphics: graphics,
      interactive: 'scroll drag'
    })
    renderer.run()
    svgPanZoom('#myDiv', {
      zoomEnabled: true,
      controlIconsEnabled: true,
      center: true,
      mouseWheelZoomEnabled: true,
      preventMouseEventsDefault: true,
      zoomScaleSensitivity: 0.2,
      minZoom: 0.2,
      maxZoom: 10
    })
    renderer.reset()
  } */
}

</script>
